Migrate to dpkg --add-architecture to track foreign architecture in template lxc-ubuntu

Bug #1017862 reported by Jean-Baptiste Lallement on 2012-06-26
10
This bug affects 1 person
Affects Status Importance Assigned to Milestone
lxc (Ubuntu)
Undecided
Stéphane Graber
Precise
High
Stéphane Graber
Quantal
Undecided
Stéphane Graber

Bug Description

The template lxc-ubuntu uses a dpkg configuration file to enable a foreign architecture when qemu-*-static is installed.

Starting from 1.16.2 dpkg added new dpkg --add-architecture and --remove-architecture commands to track supported architectures.

The configauration file /etc/dpkg/dpkg.cfg.d/lxc-multiarch shouldn't be use anymore and replaced by dpkg --add-architecture $hostarch

ProblemType: Bug
DistroRelease: Ubuntu 12.10
Package: lxc 0.8.0~rc1-4ubuntu16
ProcVersionSignature: Ubuntu 3.5.0-1.1-generic 3.5.0-rc3
Uname: Linux 3.5.0-1-generic x86_64
ApportVersion: 2.2.5-0ubuntu1
Architecture: amd64
Date: Tue Jun 26 10:41:27 2012
ProcEnviron:
 TERM=xterm
 PATH=(custom, user)
 LANG=en_US.UTF-8
 SHELL=/bin/bash
SourcePackage: lxc
UpgradeStatus: Upgraded to quantal on 2012-01-31 (146 days ago)
lxcsyslog:

[rational]
Starting with quantal, setting up multiarch needs to be done using dpkg --add-architecture instead of writing configuration files in /etc/dpkg/.
The current lxc ubuntu template in 12.04 supports quantal but won't be able to build an armhf container unless this change is applied.

[test case]
 1) lxc-create -t ubuntu -n p1 -- -r quantal -a armhf

1) should succeed, prior to that fix, it'd fail with dpkg errors.

[regression potential]
The area of the code being touched is specific to building containers of a foreign architecture, so the worst that can happen is breakage for anyone building arm/powerpc containers on x86. The change checks the dpkg version of the container, so in theory, there's no risk of change for containers < quantal.

Jean-Baptiste Lallement (jibel) wrote :
Marc Cluet (lynxman) wrote :

Confirmed, template should be upgraded

Changed in lxc (Ubuntu):
status: New → Confirmed
tags: added: rls-q-incoming
Stéphane Graber (stgraber) wrote :

I'll do that change in Quantal. Sadly Precise's dpkg is too old so we won't be able to include that in the next SRU.

Changed in lxc (Ubuntu Quantal):
assignee: nobody → Stéphane Graber (stgraber)
Stéphane Graber (stgraber) wrote :

Ignore that comment, it should actually be SRUed as it's depending on the version within the container, not outside.

So for quantal containers built on precise we'd like to use --add-architecture.

Changed in lxc (Ubuntu Quantal):
status: Confirmed → Fix Committed
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package lxc - 0.8.0~rc1-4ubuntu17

---------------
lxc (0.8.0~rc1-4ubuntu17) quantal-proposed; urgency=low

  [ Stéphane Graber ]
  * 0090-lxc-ubuntu-use-dpkg-add-architecture: Update lxc-ubuntu
    template to use "dpkg --add-architecture" in containers running
    dpkg >= 1.16.2. (LP: #1017862)

  [ Serge Hallyn ]
  * 0091-introduce-container-hooks.patch: introduce container hooks at several
    points in the container life-cycle.
  * Add copyright statement to lxc-aa-custom-profile
  * Add debian/hooks/mountcgroups as an example (installed under
    /usr/share/lxc/hooks)
 -- Serge Hallyn <email address hidden> Tue, 26 Jun 2012 13:04:01 -0500

Changed in lxc (Ubuntu Quantal):
status: Fix Committed → Fix Released
Changed in lxc (Ubuntu Precise):
assignee: nobody → Stéphane Graber (stgraber)
status: New → In Progress
description: updated
Changed in lxc (Ubuntu Precise):
importance: Undecided → High

Hello Jean-Baptiste, or anyone else affected,

Accepted lxc into precise-proposed. The package will build now and be available at http://launchpad.net/ubuntu/+source/lxc/0.7.5-3ubuntu60 in a few hours, and then in the -proposed repository.

Please help us by testing this new package. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation how to enable and use -proposed. Your feedback will aid us getting this update out to other Ubuntu users.

If this package fixes the bug for you, please change the bug tag from verification-needed to verification-done. If it does not, change the tag to verification-failed. In either case, details of your testing will help us make a better decision.

Further information regarding the verification process can be found at https://wiki.ubuntu.com/QATeam/PerformingSRUVerification . Thank you in advance!

Changed in lxc (Ubuntu Precise):
status: In Progress → Fix Committed
tags: added: verification-needed
Stéphane Graber (stgraber) wrote :

Builds the container fine and boots fine.

tags: added: verification-done
removed: verification-needed
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package lxc - 0.7.5-3ubuntu60

---------------
lxc (0.7.5-3ubuntu60) precise-proposed; urgency=low

  * Update lxc-ubuntu template to use "dpkg --add-architecture" in containers
    running dpkg >= 1.16.2. (LP: #1017862)
  * Patch lxc-clone to stop messing with dhclient.conf when it contains a
    placeholder (<hostname> or gethostname()). Fixes cases where dpkg will
    prompt for modified config file on upgrade. (LP: #1021416)
  * Allow write access to /proc/sys/kernel/shm* as these are namespaced (IPC).
    (LP: #1021411)
  * Allow fstype=fuse.*, for all containers. (LP: #1021421)
  * Rebase lxc-list on quantal's, properly shows FROZEN containers and prints
    error messages on stderr. (LP: #1021429)
  * Only run dh_apparmor against the lxc package. (LP: #1021428)
  * Depend on adduser as it's being used in postinst.
  * Fix lintian-overrides syntax.
 -- Stephane Graber <email address hidden> Thu, 05 Jul 2012 12:18:47 -0400

Changed in lxc (Ubuntu Precise):
status: Fix Committed → Fix Released
To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers